// $Id$
/**
* Copyright (C) 2015 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.handler;

import java.util.Collection;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.IHandler;
import org.eclipse.swt.SWT;

import eu.etaxonomy.cdm.model.common.CdmBase;
import eu.etaxonomy.taxeditor.model.AbstractUtility;
import eu.etaxonomy.taxeditor.model.MessagingUtils;
import eu.etaxonomy.taxeditor.session.ICdmEntitySession;
import eu.etaxonomy.taxeditor.store.CdmStore;
import eu.etaxonomy.taxeditor.view.sessions.InspectSessionsDialog;

/**
 * @author cmathew
 * @date 18 Feb 2015
 *
 */
public class OpenInspectSessionsHandler extends AbstractHandler implements IHandler {


    /* (non-Javadoc)
     * @see org.eclipse.core.commands.IHandler#execute(org.eclipse.core.commands.ExecutionEvent)
     */
    /** {@inheritDoc} */
    @Override
    public Object execute(ExecutionEvent event) throws ExecutionException {

        Object principal = CdmStore.getCurrentAuthentiation().getPrincipal();

        ICdmEntitySession activeSession = CdmStore.getCurrentSessionManager().getActiveSession();

        if(activeSession == null) {
            MessagingUtils.warningDialog("No Active Session", this, "Active Session is null");
        } else {
            Collection<CdmBase> rootEntities = activeSession.getRootEntities();
            if(rootEntities == null || rootEntities.isEmpty()) {
                MessagingUtils.warningDialog("No Root Entities", this, "No root entities to inspect");
            } else {
                InspectSessionsDialog dialog = new InspectSessionsDialog(AbstractUtility.getShell(), SWT.NONE);
                dialog.open();
            }

        }

        return null;

    }
}
