// $Id$
/**
* Copyright (C) 2014 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.newWizard;

import eu.etaxonomy.cdm.api.service.molecular.IAmplificationService;
import eu.etaxonomy.cdm.model.molecular.Amplification;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author pplitzner
 * @date 11.03.2014
 *
 */
public class NewAmplificationWizard  extends AbstractNewEntityWizard<Amplification> {

    private AmplificationGeneralWizardPage amplificationGeneralPage;

    /** {@inheritDoc} */
    @Override
    public void addPages() {
        amplificationGeneralPage = new AmplificationGeneralWizardPage(formFactory, getConversationHolder(), getEntity());
        addPage(amplificationGeneralPage);
    }

    /** {@inheritDoc} */
    @Override
    protected Amplification createNewEntity() {
        return Amplification.NewInstance();
    }

    /** {@inheritDoc} */
    @Override
    protected void saveEntity() {
        if(CdmStore.getCurrentSessionManager().isRemoting()) {
            CdmStore.getService(IAmplificationService.class).merge(getEntity(), true);
        } else {
            CdmStore.getService(IAmplificationService.class).save(getEntity());
        }
    }

    /** {@inheritDoc} */
    @Override
    public void setEntity(Amplification entity) {
        super.setEntity(entity);
        amplificationGeneralPage.getDetailElement().setEntity(entity);
    }

    @Override
    protected String getEntityName() {
        return "Amplification";
    }
}
