// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.newWizard;

import eu.etaxonomy.cdm.api.application.CdmApplicationState;
import eu.etaxonomy.cdm.api.application.CdmChangeEvent;
import eu.etaxonomy.cdm.api.application.CdmChangeEvent.Action;
import eu.etaxonomy.cdm.api.service.IClassificationService;
import eu.etaxonomy.cdm.model.taxon.Classification;
import eu.etaxonomy.taxeditor.store.CdmStore;
import eu.etaxonomy.taxeditor.ui.section.classification.ClassificationWizardPage;

/**
 * <p>ClassificationWizard class.</p>
 *
 * @author n.hoffmann
 * @created 23.06.2009
 * @version 1.0
 */

public class NewClassificationWizard extends AbstractNewEntityWizard<Classification> {

	private ClassificationWizardPage classificationWizardPage;

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.newWizard.AbstractNewEntityWizard#setEntity(java.lang.Object)
	 */
	@Override
	public void setEntity(Classification entity) {
		setWindowTitle(String.format("Edit %s", getEntityName()));
		entity = CdmStore.getService(IClassificationService.class).load(entity.getUuid());
		super.setEntity(entity);
	}

	@Override
	public void addPages() {
		classificationWizardPage = new ClassificationWizardPage(formFactory, getConversationHolder(), getEntity());
		addPage(classificationWizardPage);
	}

	@Override
	protected void saveEntity() {
		//CdmStore.getService(IClassificationService.class).saveOrUpdate(getEntity());
	    Classification classification = getEntity();
	    if(CdmStore.getCurrentSessionManager().isRemoting()) {
	        CdmStore.getService(IClassificationService.class).merge(getEntity(), true);
	        CdmApplicationState.getCurrentDataChangeService()
	        .fireChangeEvent(new CdmChangeEvent(Action.Create, classification, NewTaxonNodeWizard.class), true);
	    } else {
	        CdmStore.getService(IClassificationService.class).save(getEntity());
	    }

	}

	@Override
	protected Classification createNewEntity() {
		return Classification.NewInstance(null);
	}

	@Override
	protected String getEntityName() {
		return "Classification";
	}
}
