// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.newWizard;

import eu.etaxonomy.cdm.api.service.IGroupService;
import eu.etaxonomy.cdm.model.common.Group;
import eu.etaxonomy.taxeditor.store.CdmStore;
import eu.etaxonomy.taxeditor.ui.section.group.GroupDetailWizardPage;

/**
 * @author n.hoffmann
 * @created Mar 10, 2011
 * @version 1.0
 */
public class NewGroupWizard extends AbstractNewEntityWizard<Group> {

	private GroupDetailWizardPage groupPage;

	/* (non-Javadoc)
	 * @see org.eclipse.jface.wizard.Wizard#addPages()
	 */
	@Override
	public void addPages() {
		groupPage = new GroupDetailWizardPage(formFactory, getConversationHolder(), getEntity());
		super.addPage(groupPage);
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.newWizard.AbstractNewEntityWizard#saveEntity()
	 */
	@Override
	protected void saveEntity() {
	    if(CdmStore.getCurrentSessionManager().isRemoting()) {
	        CdmStore.getService(IGroupService.class).merge(getEntity(), true);
	    } else {
	        CdmStore.getService(IGroupService.class).save(getEntity());
	    }
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.newWizard.AbstractNewEntityWizard#createNewEntity()
	 */
	@Override
	protected Group createNewEntity() {
		return Group.NewInstance();
	}

	@Override
	protected String getEntityName() {
		return "Group";
	}

}
