// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.newWizard;

import eu.etaxonomy.cdm.api.service.ITaxonService;
import eu.etaxonomy.cdm.model.name.NonViralName;
import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.taxeditor.store.CdmStore;
import eu.etaxonomy.taxeditor.ui.section.name.NonViralNameWizardPage;
import eu.etaxonomy.taxeditor.ui.section.taxon.TaxonWizardPage;

/**
 *
 * @author pplitzner
 * @date Jan 18, 2016
 *
 */
public class NewTaxonWizard extends AbstractNewEntityWizard<Taxon> {

	private TaxonWizardPage taxonWizardPage;

	/** {@inheritDoc} */
	@Override
	public void addPages() {
	    addPage(new NonViralNameWizardPage(formFactory, getConversationHolder(), (NonViralName) getEntity().getName()));
		taxonWizardPage = new TaxonWizardPage(formFactory, getConversationHolder(), getEntity());
		addPage(taxonWizardPage);
	}

	/** {@inheritDoc} */
	@Override
	protected Taxon createNewEntity() {
		return Taxon.NewInstance(NonViralName.NewInstance(null), null);
	}

	/** {@inheritDoc} */
	@Override
	protected void saveEntity() {
	    CdmStore.getService(ITaxonService.class).save(getEntity());
	}

	/** {@inheritDoc} */
	@Override
	public void setEntity(Taxon entity) {
		super.setEntity(entity);
	}

	@Override
	protected String getEntityName() {
		return "Taxon";
	}
}
