/**
 *
 */
package eu.etaxonomy.taxeditor.newWizard;

import eu.etaxonomy.cdm.api.service.IUserService;
import eu.etaxonomy.cdm.model.common.User;
import eu.etaxonomy.taxeditor.store.CdmStore;
import eu.etaxonomy.taxeditor.ui.section.user.UserDetailWizardPage;

/**
 * @author n.hoffmann
 *
 */
public class NewUserWizard extends AbstractNewEntityWizard<User> {

	private UserDetailWizardPage userPage;

	@Override
	public void addPages() {
		userPage = new UserDetailWizardPage(formFactory, getConversationHolder(), getEntity());
		addPage(userPage);
	}

	@Override
	protected void saveEntity() {
	    if(CdmStore.getCurrentSessionManager().isRemoting()) {
	        CdmStore.getService(IUserService.class).merge(getEntity(), true);
	    } else {
	        CdmStore.getService(IUserService.class).save(getEntity());
	    }
	}

	@Override
	protected User createNewEntity() {
		return User.NewInstance(null, null);
	}

	@Override
	protected String getEntityName() {
		return "Institution";
	}

}
