// $Id$
/**
* Copyright (C) 2015 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.operation;

import java.io.Serializable;
import java.util.UUID;

import org.eclipse.swt.widgets.Display;

import eu.etaxonomy.cdm.api.application.CdmApplicationState;

/**
 * Default implementation of the {@link IFeedbackGenerator} interface.
 *
 * @author cmathew
 * @date 29 Oct 2015
 *
 */
public abstract class FeedbackGenerator implements IFeedbackGenerator {


    /**
     * Generates feedback for a waiting remoting progress monitor
     *
     * @return feedback object
     */
    public abstract Serializable generateFeedback();

    /**
     * {@inheritDoc}
     */
    @Override
    public void setFeedbackForMonitor(final UUID uuid) {
        Display.getDefault().syncExec(new Runnable() {
            @Override
            public void run() {
                CdmApplicationState.getCurrentAppConfig().getProgressMonitorService().setFeedback(uuid, generateFeedback());
            }
        });
    }

}
