// $Id$
/**
 * Copyright (C) 2007 EDIT
 * European Distributed Institute of Taxonomy
 * http://www.e-taxonomy.eu
 *
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */

package eu.etaxonomy.taxeditor.preference;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;

import eu.etaxonomy.taxeditor.preference.menu.CdmPreferencePage;
import eu.etaxonomy.taxeditor.store.CdmStore;
import eu.etaxonomy.taxeditor.ui.element.CommandHandlerButton;

/**
 * <p>
 * FeatureTreePreferences class.
 * </p>
 *
 * @author n.hoffmann
 * @created Aug 5, 2010
 * @version 1.0
 */
public class FeatureTreePreferences extends CdmPreferencePage implements
		IWorkbenchPreferencePage {

	/**
	 * <p>
	 * Constructor for FeatureTreePreferences.
	 * </p>
	 */
	public FeatureTreePreferences() {
	}

	/**
	 * <p>
	 * Constructor for FeatureTreePreferences.
	 * </p>
	 *
	 * @param title
	 *            a {@link java.lang.String} object.
	 */
	public FeatureTreePreferences(String title) {
		super(title);
	}

	/**
	 * <p>
	 * Constructor for FeatureTreePreferences.
	 * </p>
	 *
	 * @param title
	 *            a {@link java.lang.String} object.
	 * @param image
	 *            a {@link org.eclipse.jface.resource.ImageDescriptor} object.
	 */
	public FeatureTreePreferences(String title, ImageDescriptor image) {
		super(title, image);
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see
	 * org.eclipse.ui.IWorkbenchPreferencePage#init(org.eclipse.ui.IWorkbench)
	 */
	/** {@inheritDoc} */
	@Override
	public void init(IWorkbench workbench) {
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see
	 * org.eclipse.jface.preference.PreferencePage#createContents(org.eclipse
	 * .swt.widgets.Composite)
	 */
	/** {@inheritDoc} */
	@Override
	protected Control createContents(Composite parent) {
		Composite composite = new Composite(parent, SWT.NULL);
		composite.setLayout(new GridLayout());

		final CommandHandlerButton button_openFeatureTree = new CommandHandlerButton(composite, SWT.PUSH, "eu.etaxonomy.taxeditor.store.open.FeatureTreeEditorWizard");
		button_openFeatureTree.setText("Open FeatureTree Editor");
		PreferencesUtil.recursiveSetEnabled(composite, CdmStore.isActive());
		return composite;
	}
}
