package eu.etaxonomy.taxeditor.preference;

import java.io.IOException;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.preference.PreferencePage;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;
import org.eclipse.ui.PlatformUI;

import eu.etaxonomy.taxeditor.Messages;

public class OrderPreferences extends PreferencePage implements IWorkbenchPreferencePage {
	

	    boolean isNaturalOrderActivated;
	    boolean isSelectionChanged = false;
	    /*
	     * (non-Javadoc)
	     *
	     * @see
	     * org.eclipse.jface.preference.FieldEditorPreferencePage#createFieldEditors
	     * ()
	     */
	    @Override
	    protected Control createContents(Composite parent) {

	        Composite composite = new Composite(parent, SWT.NULL);
	        composite.setLayout(new GridLayout());
	        final Label description = new Label(parent, SWT.NONE);
	        description.setText(Messages.OrderPreferencePage_NewNavigatorWindowRequired);
	        isNaturalOrderActivated = PreferencesUtil.getPreferenceStore().getBoolean(IPreferenceKeys.SORT_NODES_NATURALLY);
	        final Button activateCheckButton = new Button(composite, SWT.CHECK);
	        activateCheckButton.setText("Enable Natural Order");
	        activateCheckButton.setSelection(isNaturalOrderActivated);
	        activateCheckButton.addSelectionListener(new SelectionAdapter(){
	            @Override
	            public void widgetSelected(SelectionEvent e) {
	            	if(isNaturalOrderActivated != activateCheckButton.getSelection()) {
	                	isNaturalOrderActivated = activateCheckButton.getSelection();
	                	PreferencesUtil.getPreferenceStore().setValue(IPreferenceKeys.SORT_NODES_NATURALLY, isNaturalOrderActivated);
                        isSelectionChanged = true;
                    }else{
                        isSelectionChanged = false;
                    }

	            }
	        });

	       

	        return composite;
	    }

	  
		@Override
		public void init(IWorkbench workbench) {
			// TODO Auto-generated method stub
			
		}

		/* (non-Javadoc)
		 * @see org.eclipse.jface.preference.PreferencePage#performOk()
		 */
		@Override
		public boolean performOk() {
	       if(isSelectionChanged){
	    	  MessageDialog.openInformation(getShell(), null, Messages.OrderPreferencePage_PleaseReopenNavigator);	          
			return super.performOk();
	       }
	       return true;
		}


}
