// $Id$
/**
* Copyright (C) 2012 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.section.group;

import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
import eu.etaxonomy.cdm.model.common.Group;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;

/**
 * @author a.kohlbecker
 *
 */
public class GroupSelectionElement extends EntitySelectionElement<Group> {
	
	public GroupSelectionElement(CdmFormFactory formFactory,
			ConversationHolder conversation, ICdmFormElement parentElement,
			String labelString, Group entity, int mode,
			int style) {
		super(formFactory, conversation, parentElement, Group.class, labelString, entity,
				mode, style);
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement#getTitle()
	 */
	@Override
	protected String getTitle() {
		if (getEntity() != null) {
			return getEntity().getName();
		}
		return super.getTitle();
	}

}
