// $Id$
/**
 * Copyright (C) 2007 EDIT
 * European Distributed Institute of Taxonomy 
 * http://www.e-taxonomy.eu
 * 
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */

package eu.etaxonomy.taxeditor.ui.section.group;

import org.eclipse.swt.events.SelectionListener;

import eu.etaxonomy.cdm.model.common.User;
import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement;
import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;

/**
 * @author n.hoffmann
 * @created Mar 9, 2011
 * @version 1.0
 */
public class MemberDetailElement extends AbstractEntityCollectionElement<User> {

	private EntitySelectionElement<User> selection_user;

	/**
	 * @param formFactory
	 * @param section
	 * @param entity
	 * @param removeListener
	 * @param backgroundColor
	 * @param style
	 */
	public MemberDetailElement(CdmFormFactory formFactory,
			AbstractFormSection section, User entity,
			SelectionListener removeListener, int style) {
		super(formFactory, section, entity, removeListener, null, style);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement#setEntity
	 * (java.lang.Object)
	 */
	@Override
	public void setEntity(User entity) {
		selection_user.setEntity(entity);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement#
	 * createControls(eu.etaxonomy.taxeditor.ui.forms.ICdmFormElement, int)
	 */
	@Override
	public void createControls(ICdmFormElement element, int style) {
		selection_user = formFactory
				.createSelectionElement(User.class,
						getConversationHolder(), element, "", entity,
						EntitySelectionElement.EDITABLE, style);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement#handleEvent
	 * (java.lang.Object)
	 */
	@Override
	public void handleEvent(Object eventSource) {
		if (eventSource == selection_user) {
			setEntity(selection_user.getEntity());
		}
	}

}
