/**
 * 
 */
package eu.etaxonomy.taxeditor.ui.section.key;

import java.util.Collection;

import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
import eu.etaxonomy.cdm.model.common.DefinedTerm;
import eu.etaxonomy.cdm.model.common.TermType;
import eu.etaxonomy.cdm.model.description.PolytomousKey;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionSection;

/**
 * @author n.hoffmann
 *
 */
public class ScopeRestrictionSection extends AbstractEntityCollectionSection<PolytomousKey, DefinedTerm> {

	public ScopeRestrictionSection(CdmFormFactory formFactory,
			ConversationHolder conversation, ICdmFormElement parentElement, int style) {
		super(formFactory, conversation, parentElement, "Scope Restriction", style);
	}

	@Override
	public Collection<DefinedTerm> getCollection(PolytomousKey entity) {
		return entity.getScopeRestrictions();
	}

	@Override
	public DefinedTerm createNewElement() {		
		return DefinedTerm.NewInstance(TermType.Scope,"","Untitled","");
			
	}

	@Override
	public void addElement(DefinedTerm element) {
		getEntity().addScopeRestriction(element);
	}

	@Override
	public void removeElement(DefinedTerm element) {
		getEntity().removeScopeRestriction(element);
	}

	@Override
	public String getEmptyString() {
		return "No scope restrictions yet.";
	}

	@Override
	protected String getTooltipString() {
		return "Add a scope restriction";
	}

}
