// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.ui.section.supplemental;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionListener;

import eu.etaxonomy.cdm.model.common.OriginalSourceBase;
import eu.etaxonomy.cdm.model.common.OriginalSourceType;
import eu.etaxonomy.taxeditor.ui.combo.EnumComboElement;
import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;

/**
 * @author n.hoffmann
 * @created Mar 16, 2010
 * @version 1.0
 */
public abstract class AbstractOriginalSourceElement<T extends OriginalSourceBase> extends AbstractReferencedEntityElement<T> {
	protected EnumComboElement<OriginalSourceType> combo_origsourcetype;
	protected TextWithLabelElement text_idInSource;
	protected TextWithLabelElement text_idNamespace;
    protected TextWithLabelElement text_originaleNameString;

	public AbstractOriginalSourceElement(CdmFormFactory formFactory,
			AbstractFormSection section,
			T element, SelectionListener removeListener,
			int style) {
		super(formFactory, section, element, removeListener, style);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void setEntity(T entity) {
	    super.setEntity(entity);
        text_originaleNameString.setText(entity.getOriginalNameString());
	}

	/** {@inheritDoc} */
	@Override
	public void createControls(ICdmFormElement formElement, int style) {
		combo_origsourcetype = formFactory
				.createEnumComboElement(OriginalSourceType.class,
						formElement, style);
		super.createControls(formElement, style);
		text_idInSource = formFactory.createTextWithLabelElement(formElement, "ID in Source", null, style);
		text_idNamespace = formFactory.createTextWithLabelElement(formElement, "ID Namespace", null, style);
		text_originaleNameString = formFactory.createTextWithLabelElement(
		        formElement, "Original Name", null, SWT.NULL);
	}
}
