// $Id$
/**
* Copyright (C) 2009 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.section.vocabulary;

import org.apache.commons.lang.StringUtils;

import eu.etaxonomy.cdm.model.common.DefinedTermBase;
import eu.etaxonomy.cdm.model.common.TermVocabulary;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;

/**
 * @author l.morris
 * @date 20 Dec 2011
 *
 */
public class DefinedTermDetailElement<T extends DefinedTermBase> extends AbstractTermBaseDetailElement<T> {

    protected TextWithLabelElement textIdInVocabulary;

	/**
	 * @param formFactory
	 * @param formElement
	 */
	public DefinedTermDetailElement(CdmFormFactory formFactory,
			ICdmFormElement formElement) {
		super(formFactory, formElement);
	}

	@Override
    protected void createControls(ICdmFormElement formElement, T entity, int style) {
	    super.createControls(formElement, entity, style);
	    textIdInVocabulary = formFactory.createTextWithLabelElement(formElement, "ID in vocabulary", entity.getIdInVocabulary(), style);
	};

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement#handleEvent(java.lang.Object)
	 */
	@Override
	public void handleEvent(Object eventSource) {
		handleRepresentation(eventSource);
		if(eventSource==textIdInVocabulary){
			if (StringUtils.isBlank(textIdInVocabulary.getText())){
				getEntity().setIdInVocabulary(null);
			}else{
				getEntity().setIdInVocabulary(textIdInVocabulary.getText());
			}
		    
		}
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.ui.section.vocabulary.AbstractTermBaseDetailElement#getVocabularyMarkers()
	 */
	@Override
	public TermVocabulary getVocabulary() {
		return getEntity() != null ? getEntity().getVocabulary() : null;
	}

}
