// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.util;

import org.eclipse.core.runtime.Platform;
import org.osgi.framework.Bundle;

import eu.etaxonomy.taxeditor.model.AbstractUtility;

/**
 * <p>ApplicationUtil class.</p>
 *
 * @author n.hoffmann
 * @created Oct 13, 2010
 * @version 1.0
 */
public class ApplicationUtil extends AbstractUtility {


    /**
     * Prefix to declare the version as beta
     */
    private static final String BETA_PREFIX = "[BETA]";

    public static String getTitle() {
        return "EDIT Taxonomic Editor " + ApplicationUtil.getVersion();
    }
    /**
     * @return
     */
    public static String getVersion() {
        Bundle bundle = Platform.getBundle("eu.etaxonomy.taxeditor.application");
        String version = bundle.getHeaders().get(org.osgi.framework.Constants.BUNDLE_VERSION);
        // Checking if this is a beta (snapshot) version
        if(version ==null || version.isEmpty()) {
            return "";
        }
        String[] parts = version.split("\\.");
        if(parts.length <= 3) {
            // this is a stable version
            return version;
        } else {
            return BETA_PREFIX + " " + version + " UTC";
        }

    }

    /**
     * @return
     */
    public static boolean isStable() {
        return !getVersion().startsWith("[");
    }


}
