// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.view.datasource.handler;

import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.handlers.HandlerUtil;

import eu.etaxonomy.cdm.database.CdmPersistentDataSource;
import eu.etaxonomy.taxeditor.datasource.CdmDataSourceRepository;
import eu.etaxonomy.taxeditor.view.datasource.CdmMetaDataAwareDataSourceContainer;

/**
 * @author n.hoffmann
 * @created 15.04.2009
 * @version 1.0
 */
public class DeleteDataSourceHandler extends AbstractDataSourceHandler {

	/** {@inheritDoc} */
	@Override
	public boolean specificExecute(ExecutionEvent event) {
		ISelection selection = HandlerUtil.getActivePart(event).getSite().getSelectionProvider().getSelection();
		if(selection instanceof IStructuredSelection){
			Object[] selectedObjects = ((IStructuredSelection) selection).toArray();

			if(! MessageDialog.openConfirm(HandlerUtil.getActiveShell(event), "Confirm Deletion", "Do you want to delete the selected datasources?")){
				return false;
			}
			// Delete from persistent data sources
			for(Object object : selectedObjects){
				CdmPersistentDataSource dataSource = (CdmPersistentDataSource) ((CdmMetaDataAwareDataSourceContainer) object).getCdmSource();
				CdmDataSourceRepository.delete(dataSource);
			}

			return true;
		}
		return false;
	}
}
